/******************************************************************************
   1) Van ca-u_shipment_item_tariff(_old),ca-u_surcharge,ca-i_shipment_item_tariff
      veld chargecode overkopieeeren naar costcode.
*******************************************************************************/

/*--indien al een keer uitgevoerd, dan overslaan --*/
IF CAN-FIND(FIRST sp-control WHERE
                  sp-control.controlkode EQ THIS-PROCEDURE:FILE-NAME )
THEN RETURN.

DEF VAR cProgram  AS CHAR   NO-UNDO.
DEF VAR cAction   AS CHAR   NO-UNDO.
DEF VAR cTable    AS CHAR   NO-UNDO.
DEF VAR iTotal    AS INT    NO-UNDO.
DEF VAR iDone     AS INT    NO-UNDO.
DEF VAR iModulo   AS INT    NO-UNDO.
DEF VAR cTables   AS CHAR   NO-UNDO.
DEF VAR cDumpFile AS CHAR   NO-UNDO.
DEF VAR cLine     AS CHAR   NO-UNDO.
DEF VAR cCompany  AS CHAR   NO-UNDO.
DEF VAR iSeqNr    AS INT    NO-UNDO.
DEF VAR cCostCd   AS CHAR   NO-UNDO.

ASSIGN cProgram  = THIS-PROCEDURE:FILE-NAME
       cAction   = ''
       iModulo   = 100 /* om de 100 records info tonen */
       cTables   = 'ca-u_shipment_item_tariff,'
                 + 'ca-u_shipment_item_tariff_old,'
                 + 'ca-i_shipment_item_tariff,'
                 + 'ca-u_surcharges'. 
         
FOR FIRST sp-control NO-LOCK WHERE
          sp-control.uitleg EQ 'Copy chargecode to costcode':
   cDumpFile = sp-control.lijst-2.
END.

IF SEARCH(cDumpFile) EQ ?  
THEN DO:
   UPDATE 'dumpfile van ca-pre-01... is niet gevonden. Voer handmatig in:'
     SKIP cDumpFile FORMAT 'x(50)' WITH VIEW-AS DIALOG-BOX.
END.

FORM 'Program  :' AT 1 cProgram   NO-LABEL  FORMAT 'x(50)'    AT 12  SKIP
     'Action   :' AT 1 cAction    NO-LABEL  FORMAT 'x(50)'    AT 12  SKIP
     'Table    :' AT 1 cTable     NO-LABEL  FORMAT 'x(50)'    AT 12  SKIP
     'Total    :' AT 1 iTotal     NO-LABEL  FORMAT '9999999'  AT 12  SKIP
     'Done     :' AT 1 iDone      NO-LABEL  FORMAT '9999999'  AT 12  SKIP   
     WITH FRAME a.

&GLOBAL-DEFINE mydisplay cProgram cAction cTable iTotal iDone  WITH FRAME a

/*****************************************************************************************************
   EVEN TELLEN, 
*****************************************************************************************************/
cAction = 'Counting..' .
cTable  = 'CA-U_SHIPMENT_ITEM_TARIFF'. 
DISPLAY {&mydisplay}.
FOR EACH ca-u_shipment_item_tariff NO-LOCK:
   iTotal = iTotal + 1.
   IF iTotal MODULO iModulo EQ 0 
   THEN DISPLAY {&mydisplay}.
END.

cTable = 'CA-U_SHIPMENT_ITEM_TARIFF_OLD'. 
DISPLAY {&mydisplay}.
FOR EACH ca-u_shipment_item_tariff_old NO-LOCK:
   iTotal = iTotal + 1.
   IF iTotal MODULO iModulo EQ 0 
   THEN DISPLAY {&mydisplay}.
END.

cTable = 'CA-I_SHIPMENT_ITEM_TARIFF'. 
DISPLAY {&mydisplay}.
FOR EACH ca-i_shipment_item_tariff NO-LOCK:
   iTotal = iTotal + 1.
   IF iTotal MODULO iModulo EQ 0 
   THEN DISPLAY {&mydisplay}.
END.

cTable = 'CA-U_SURCHARGES'. 
DISPLAY {&mydisplay}.
FOR EACH ca-u_surcharges NO-LOCK:
   iTotal = iTotal + 1.
   IF iTotal MODULO iModulo EQ 0 
   THEN DISPLAY {&mydisplay}.
END.

cTable = 'sp-crossref'.
DISPLAY {&mydisplay}.
FOR EACH sp-crossref WHERE (CAN-DO(cTables,sp-crossref.rel_tabel) OR CAN-DO(cTables,sp-crossref.tabel))
                       AND (  sp-crossref.rel_veld EQ 'chargecode'
                           OR sp-crossref.van_veld EQ 'chargecode'
                           OR sp-crossref.veldnaam EQ 'chargecode' )
                     EXCLUSIVE-LOCK:
   iTotal = iTotal + 1.
   IF iTotal MODULO iModulo EQ 0 
   THEN DISPLAY {&mydisplay}.
END.

/*****************************************************************************************************
 MAIN BLOCK
 *****************************************************************************************************/
ASSIGN cTable  = 'ca-u_shipment_item_tariff'
       cAction = 'Copy chargecode to costcode'.
DISPLAY {&mydisplay}.

/*--ivm met performance triggers disablen --*/
DISABLE TRIGGERS FOR LOAD OF ca-u_shipment_item_tariff.
DISABLE TRIGGERS FOR LOAD OF ca-u_shipment_item_tariff_old.
DISABLE TRIGGERS FOR LOAD OF ca-i_shipment_item_tariff.
DISABLE TRIGGERS FOR LOAD OF ca-u_surcharges.
DISABLE TRIGGERS FOR LOAD OF sp-crossref.

FOR EACH ca-u_shipment_item_tariff EXCLUSIVE-LOCK,
   FIRST ca-u_tariff NO-LOCK WHERE
         ca-u_tariff.companycode  EQ ca-u_shipment_item_tariff.companycode
     AND ca-u_tariff.tariff_seqnr EQ ca-u_shipment_item_tariff.u_tariff_seqnr   
         TRANSACTION:
   ASSIGN iDone                              = iDone + 1
          ca-u_shipment_item_tariff.costcode = ca-u_tariff.costcode .
   IF iDone MODULO iModulo EQ 0 
   THEN DISPLAY {&mydisplay}.
END. /*each */

FOR EACH ca-u_shipment_item_tariff_old EXCLUSIVE-LOCK, 
   FIRST ca-u_tariff NO-LOCK WHERE
         ca-u_tariff.companycode  EQ ca-u_shipment_item_tariff_old.companycode
     AND ca-u_tariff.tariff_seqnr EQ ca-u_shipment_item_tariff_old.u_tariff_seqnr
         TRANSACTION:
   ASSIGN iDone                                  = iDone + 1
          ca-u_shipment_item_tariff_old.costcode = ca-u_tariff.costcode .
   IF iDone MODULO iModulo EQ 0 
   THEN DISPLAY {&mydisplay}.
END. /*each */

FOR EACH ca-i_shipment_item_tariff EXCLUSIVE-LOCK,
   FIRST ca-u_tariff NO-LOCK WHERE
         ca-u_tariff.companycode  EQ ca-i_shipment_item_tariff.companycode
     AND ca-u_tariff.tariff_seqnr EQ ca-i_shipment_item_tariff.u_tariff_seqnr      
         TRANSACTION:
   ASSIGN iDone                              = iDone + 1
          ca-i_shipment_item_tariff.costcode = ca-u_tariff.costcode .
   IF iDone MODULO iModulo EQ 0 
   THEN DISPLAY {&mydisplay}.
END. /*each */

FOR EACH sp-crossref EXCLUSIVE-LOCK WHERE 
         (   CAN-DO(cTables,sp-crossref.rel_tabel) 
          OR CAN-DO(cTables,sp-crossref.tabel))
     AND (  sp-crossref.rel_veld EQ 'chargecode'
         OR sp-crossref.van_veld EQ 'chargecode'
         OR sp-crossref.veldnaam EQ 'chargecode' )
         TRANSACTION :
   ASSIGN 
      iDone                = iDone + 1
      sp-crossref.veldnaam = 'costcode' WHEN sp-crossref.veldnaam EQ 'chargecode' 
      sp-crossref.rel_veld = 'costcode' WHEN sp-crossref.rel_veld EQ 'chargecode' 
      sp-crossref.van_veld = 'costcode' WHEN sp-crossref.van_veld EQ 'chargecode' .
   IF iDone MODULO iModulo EQ 0 
   THEN DISPLAY {&mydisplay}.
END.

IF SEARCH(cDumpFile) NE ? 
THEN DO:
   INPUT FROM VALUE(cDumpFile).
      REPEAT:
         IMPORT DELIMITER ';' cCompany cLine iSeqNr cCostCd. 
         iDone = iDone + 1.
         IF iDone MODULO iModulo EQ 0 
         THEN DISPLAY {&mydisplay}.
         FOR FIRST ca-u_surcharge EXCLUSIVE-LOCK WHERE
                   ca-u_surcharge.companycode     EQ cCompany
               AND ca-u_surcharge.linecode        EQ cLine
               AND ca-u_surcharge.surcharge_segnr EQ iSeqNr
                   TRANSACTION:
            ca-u_surcharge.costcode = cCostCd.
         END. /*FOR*/
      END. /*repeat*/
   INPUT CLOSE.
END. /*search*/

/*****************************************************************************************************
     registreren voor toekomstige runs dat deze script al is uitgevoerd en kan worden overgeslagen
*****************************************************************************************************/
ASSIGN cTable  = ''
       cAction = 'Done...' .
DISPLAY {&mydisplay}.

DO TRANSACTION:
   CREATE sp-control.
   ASSIGN sp-control.controlkode = THIS-PROCEDURE:FILE-NAME
          sp-control.lijst       = 'uitgevoerd op ' + STRING(TODAY,'99-99-9999') + ' ' + STRING(TIME,'HH:MM:SS')
          sp-control.uitleg      = 'Copy chargecode to costcode'.
END. /*transaction*/
                    

   
