/******************************************************************************
   1) Alle ca-u_tariff waarbij het veld qualifier leeg is default vullen SEA/OCEAN TRIP.
      Dit om het pre-selecteren van tarieven voor een quotation te versnellen
*******************************************************************************/
DEF VAR cProgram        AS CHAR   NO-UNDO.
DEF VAR cAction         AS CHAR   NO-UNDO.
DEF VAR cTable          AS CHAR   NO-UNDO.
DEF VAR iTotal          AS INT    NO-UNDO.
DEF VAR iDone           AS INT    NO-UNDO.
DEF VAR iModulo         AS INT    NO-UNDO.
DEF VAR cQualifierList  AS CHAR   NO-UNDO.

/*--indien al een keer uitgevoerd, dan overslaan --*/
IF CAN-FIND(FIRST sp-control WHERE
                  sp-control.controlkode EQ THIS-PROCEDURE:FILE-NAME )
THEN RETURN.

ASSIGN cProgram = THIS-PROCEDURE:FILE-NAME
       cAction  = ''
       iModulo  = 100.  /* om de 100 records info tonen */

FORM 'Program  :' AT 1 cProgram   NO-LABEL  FORMAT 'x(50)'    AT 12  SKIP
     'Action   :' AT 1 cAction    NO-LABEL  FORMAT 'x(50)'    AT 12  SKIP
     'Table    :' AT 1 cTable     NO-LABEL  FORMAT 'x(50)'    AT 12  SKIP
     'Total    :' AT 1 iTotal     NO-LABEL  FORMAT '9999999'  AT 12  SKIP
     'Done     :' AT 1 iDone      NO-LABEL  FORMAT '9999999'  AT 12  SKIP   
     WITH FRAME a.

&GLOBAL-DEFINE mydisplay cProgram cAction cTable iTotal iDone  WITH FRAME a

FOR EACH aa-systemcode WHERE
         aa-systemcode.systemtype EQ 'tp_trip_type'
         NO-LOCK:
   cQualifierList = LEFT-TRIM(cQualifierList + ',' + aa-systemcode.systemcode,',').         
END. /*each*/

/*****************************************************************************************************
   EVEN TELLEN, 
*****************************************************************************************************/
cAction = 'Counting..' .
cTable  = 'ca-u_tariff'. 
DISPLAY {&mydisplay}.
FOR EACH ca-u_tariff WHERE 
         NOT CAN-DO(cQualifierList,ca-u_tariff.qualifier) 
         NO-LOCK:
   iTotal = iTotal + 1.
   IF iTotal MODULO iModulo EQ 0 
   THEN DISPLAY {&mydisplay}.
END.

/*****************************************************************************************************
 MAIN BLOCK
 *****************************************************************************************************/
ASSIGN cTable  = 'ca-u_tariff'
       cAction = ''.
DISPLAY {&mydisplay}.

/*--ivm met performance triggers disablen --*/
DISABLE TRIGGERS FOR LOAD OF ca-u_tariff.

FOR EACH ca-u_tariff WHERE 
         NOT CAN-DO(cQualifierList,ca-u_tariff.qualifier)
         EXCLUSIVE-LOCK TRANSACTION:
   ASSIGN 
      iDone                 = iDone + 1
      ca-u_tariff.qualifier = 'SEA/OCEAN TRIP'.
          
   IF iDone MODULO iModulo EQ 0 
   THEN DISPLAY {&mydisplay}.
END. /*each */

/*****************************************************************************************************
     registreren voor toekomstige runs dat deze script al is uitgevoerd en kan worden overgeslagen
*****************************************************************************************************/
ASSIGN cTable  = ''
       cAction = 'Done...' .
DISPLAY {&mydisplay}.

DO TRANSACTION:
   CREATE sp-control.
   ASSIGN sp-control.controlkode = THIS-PROCEDURE:FILE-NAME
          sp-control.lijst       = 'uitgevoerd op ' + STRING(TODAY,'99-99-9999') + ' ' + STRING(TIME,'HH:MM:SS')
          sp-control.uitleg      = 'fill empty ca-u_tariff.qualifier with default SEA/OCEAN TRIP'.
END. /*transaction*/
                    

